/****************************************************************************
** 2001 - Hans Opstaele 
****************************************************************************/
#include "settings.h"

#include <qcombobox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qwidget.h>
#include <qlabel.h>

Config config[]={
  { "#Points (10..100)", "50" , "Number  of segments of the\n rope." },
  { "Speed Simul. (ms)", "50", "Time between each frame." },
  { "Simulated time (dT)", "0.01", "Simulated time per frame." },
  { "Simulated distance (dX)", "0.01","Simulated length per rope\n segment." },
  { "Simulated mass (dM)", "1.0", "Simulated mass per rope\n segment." },
  { "Simulated stretch (F)", "1.0" , "Pulling force on the rope." },
  { "End (open/closed)", "open", "Right rope-end follows\n (open) or is fixed\n (closed)." },
  { "Function", "puls", "Function that is forced at\n the left rope-end.\n [sinus, puls, complex] " },
      
  { NULL, "" } 
};

/* 
 */
Settings::Settings( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    resize( 380 , 150 ); 
    setCaption("settings...");

    ComboBox1 = new QComboBox( FALSE, this, "ComboBox1" );

    for (int i=0; config[i].key;++i)
    {
      ComboBox1->insertItem( config[i].key );
    }
    ComboBox1->setGeometry( QRect( 5, 25, 170, 30 ) ); 
    QObject::connect( ComboBox1, SIGNAL(activated( int ) ), this, SLOT( slotUpdate( int ) ) );

    LineEdit1     = new QLineEdit(	 this, "value" );
    LineEdit1->setGeometry( 200, 25, 150, 30 );
    Label1 = new QLabel( "some help", this, "descr" );
    Label1->setGeometry( 5, 70, 170, 60 );
    Label1->setFrameStyle( QFrame::Panel | QFrame::Sunken );
    Label2 = new QLabel( "NOTE: Pressing 'Apply'\n resets the time.", this, "descr2" );
    Label2->setGeometry( 200, 85, 150, 50 );
     

    /* some buttons
     */
    buttonApply = new QPushButton( "apply", this );
    buttonApply->setDefault( TRUE );
    buttonApply->setGeometry( 290, 70, 60, 20 );

    // signals and slots connections
    connect( buttonApply, SIGNAL( clicked() ), this, SLOT( slotApply() ) );
    connect( buttonApply, SIGNAL( clicked() ), parent, SLOT( slotReset() ) );

    slotUpdate(0);
}

/*  
 *  Destroys the object and frees any allocated resources
 */
Settings::~Settings()
{
    // no need to delete child widgets, Qt does it all for us
}

void Settings::slotApply()
{
  strncpy( config[ ComboBox1->currentItem() ].val, LineEdit1->text() , 256 );
  
}

void Settings::slotUpdate(int it)
{
  LineEdit1->setText( config[it].val );
  Label1->setText( config[it].descr );
}

